#include <windows.h>
#include <windowsx.h>
#include <winuser.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

//define the name for our window
#define NAME "WINTUT2"

// define the title for our window
#define TITLE "A Windows program with a window"

// our callback procedure
long FAR PASCAL WndProc(HWND hWnd, WORD iMessage, WORD wParam, LONG lParam)
{
	 HDC pDC;										// our device context
	 PAINTSTRUCT PtStr;								// our PAINSTRUCT

	 switch(iMessage)								// what message was sent?
	 {
		  case WM_PAINT:							// the repaint the window message
		  {
				pDC = BeginPaint(hWnd, &PtStr);		// being painting
				EndPaint(hWnd, &PtStr);				// end painting
				return(0);
		  }
		  case WM_KEYDOWN:							// a key was pressed
		  {
				switch(wParam)						// what key?
				{
					 case VK_ESCAPE:				// the escape key
					 {
						  DestroyWindow(hWnd);      // destroy the window
						  return 0;
					 }
				}
		  }
		  break;
		  case WM_DESTROY:							// the window was destroyed
		  {
				PostQuitMessage(0);					// we are quitting
				return 0;
		  }
	 }
	 return(DefWindowProc(hWnd, iMessage, wParam, lParam));
	 // the defwindowproc is used to ensure all messages were processed
}

// our main function
int PASCAL WinMain(HANDLE hInstance, HANDLE hPrevInstance, LPSTR lpszCmdParam, int nCmdShow)
{
	 MSG Message;			// our message variable
	 WNDCLASS WndClass;		// our window structure
	 HWND hWnd;				// our window handle

	 if(!hPrevInstance)		// is the app already open?
	 {
		  // customise our window
		  WndClass.cbClsExtra = 0;
		  WndClass.cbWndExtra = 0;
		  WndClass.hbrBackground = GetStockObject(WHITE_BRUSH);
		  WndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
		  WndClass.hIcon = LoadIcon(NULL, IDI_APPLICATION);
		  WndClass.hInstance = hInstance;
		  WndClass.lpfnWndProc = (WNDPROC) WndProc;
		  WndClass.lpszClassName = NAME;
		  WndClass.lpszMenuName = NULL;
		  WndClass.style = CS_HREDRAW | CS_VREDRAW | CS_DBLCLKS;

		  // register our window
		  RegisterClass(&WndClass);
	 }

	 // create our window
	 hWnd = CreateWindowEx(WS_EX_TOPMOST, NAME, TITLE,
								WS_OVERLAPPEDWINDOW,
								0,0,640,480,NULL,NULL,hInstance,NULL);

	 // show our window
	 ShowWindow(hWnd, SW_SHOWNORMAL);

	 // update our window
	 UpdateWindow(hWnd);

	 // our message loop
	 while(GetMessage(&Message, 0, 0, 0))	// get the message
	 {
		TranslateMessage(&Message);			// translate the message
		DispatchMessage(&Message);			// send the message
	}

	return Message.wParam;					// return a value to the OS
}
